=== removed file 'lib/canonical/launchpad/doc/vocabulary-json.txt'
--- lib/canonical/launchpad/doc/vocabulary-json.txt	2011-08-04 05:37:42 +0000
+++ lib/canonical/launchpad/doc/vocabulary-json.txt	1970-01-01 00:00:00 +0000
@@ -1,224 +0,0 @@
-= View to export Vocabularies as  JSON =
-
-This view provides a simple means for AJAX widgets to retrieve vocabulary
-entries until vocabularies are integrated into the REST API.
-
-    >>> from canonical.launchpad.interfaces.launchpad import ILaunchpadRoot
-    >>> import simplejson
-    >>> from urllib import urlencode
-    >>> root = getUtility(ILaunchpadRoot)
-    >>> def print_json(json):
-    ...     data = simplejson.loads(json)
-    ...     print simplejson.dumps(data, sort_keys=True, indent=4)
-    >>> def create_vocabulary_view(form, context=root):
-    ...     # The BatchNavigator looks in the query string for GET requests.
-    ...     query_string = urlencode(form)
-    ...     return create_view(context, '+huge-vocabulary',
-    ...                        form=form, query_string=query_string)
-
-The view requires the name of the vocabulary.
-
-    >>> view = create_vocabulary_view({})
-    >>> print_json(view())
-    Traceback (most recent call last):
-    ...
-    MissingInputError: ('name', '', None)
-
-Since it is exporting huge vocabularies, it requires a search term.
-
-    >>> form = dict(name='ValidPerson')
-    >>> view = create_vocabulary_view(form)
-    >>> print_json(view())
-    Traceback (most recent call last):
-    ...
-    MissingInputError: ('search_text', '', None)
-
-The name must be a valid vocabulary.
-
-    >>> form = dict(name='invalid-vocabulary', search_text='foo')
-    >>> view = create_vocabulary_view(form)
-    >>> print_json(view())
-    Traceback (most recent call last):
-    ...
-    UnexpectedFormData: Unknown vocabulary 'invalid-vocabulary'
-
-To use the new disclosure functionality, we need to turn on the feature flag.
-    >>> from lp.services.features.testing import FeatureFixture
-    >>> feature_flag = {'disclosure.picker_enhancements.enabled': 'on'}
-    >>> flags = FeatureFixture(feature_flag)
-    >>> flags.setUp()
-
-A successful search.
-
-    >>> form = dict(name='ValidPersonOrTeam', search_text='guadamen')
-    >>> view = create_vocabulary_view(form)
-    >>> print_json(view())
-    {
-        "entries": [
-            {
-                "alt_title": "guadamen",
-                "alt_title_link": "http://launchpad.dev/~guadamen",
-                "api_uri": "/~guadamen",
-                "css": "sprite team",
-                "link_css": "js-action",
-                "metadata": "team",
-                "title": "GuadaMen",
-                "value": "guadamen"
-            }
-        ],
-        "total_size": 1
-    }
-
-Multiple entries.
-
-    >>> form = dict(name='ValidPersonOrTeam', search_text='admin')
-    >>> view = create_vocabulary_view(form)
-    >>> result = simplejson.loads(view())
-    >>> result['total_size']
-    6
-    >>> len(result['entries'])
-    5
-
-Size and offset parameters can be passed in to switch between batches.
-
-    >>> form = dict(name='ValidPersonOrTeam', search_text='admin',
-    ...             start='0', batch='1')
-    >>> view = create_vocabulary_view(form)
-    >>> print_json(view())
-    {
-        "entries": [
-            {
-                "alt_title": "commercial-admins",
-                "alt_title_link": "http://launchpad.dev/~commercial-admins",
-                "api_uri": "/~commercial-admins",
-                "css": "sprite team",
-                "link_css": "js-action",
-                "metadata": "team",
-                "title": "Commercial Subscription Admins",
-                "value": "commercial-admins"
-            }
-        ],
-        "total_size": 6
-    }
-
-    >>> form = dict(name='ValidPersonOrTeam', search_text='admin',
-    ...             start='1', batch='1')
-    >>> view = create_vocabulary_view(form)
-    >>> print_json(view())
-    {
-        "entries": [
-            {
-                "alt_title": "launchpad-buildd-admins",
-                "alt_title_link":
-                    "http://launchpad.dev/~launchpad-buildd-admins",
-                "api_uri": "/~launchpad-buildd-admins",
-                "css": "sprite team",
-                "link_css": "js-action",
-                "metadata": "team",
-                "title": "Launchpad Buildd Admins",
-                "value": "launchpad-buildd-admins"
-            }
-        ],
-        "total_size": 6
-    }
-
-If a person is affiliated with the view context, the relevant badge(s) will be
-included in the picker entry.
-
-    >>> from zope.component import getUtility
-    >>> from lp.bugs.interfaces.bugtask import IBugTaskSet
-    >>> bugtask = getUtility(IBugTaskSet).get(2)
-    >>> form = dict(name='ValidPersonOrTeam', search_text='name12',
-    ...             start='0', batch='1')
-    >>> view = create_vocabulary_view(form, context=bugtask)
-    >>> print_json(view())
-    {
-        "entries": [
-            {
-                "alt_title": "name12",
-                "alt_title_link": "http://launchpad.dev/~name12",
-                "api_uri": "/~name12",
-                "badges": [
-                     {
-                         "alt": "Affiliated with Launchpad itself",
-                         "url": "/@@/product-badge"
-                     }
-                 ],
-                "css": "sprite person",
-                "description": "<email address hidden>",
-                "link_css": "js-action",
-                "metadata": "person",
-                "title": "Sample Person",
-                "value": "name12"
-            }
-        ],
-        "total_size": 1
-    }
-
-Long descriptions will be truncated.
-
-    >>> form = dict(name='ProjectGroup', search_text='apache')
-    >>> view = create_vocabulary_view(form)
-    >>> print_json(view())
-    {
-        "entries": [
-            {
-                "api_uri": "/apache",
-                "css": "sprite project",
-                "description": "The Apache projects are characterized by...
-                "title": "Apache",
-                "value": "apache"
-            }
-        ],
-        "total_size": 1
-    }
-
-Hidden email addresses should also be hidden when IPerson objects are
-retrieved through vocabularies.
-
-    >>> form = dict(name='ValidPersonOrTeam', search_text='name12',
-    ...             start='0', batch='1')
-    >>> view = create_vocabulary_view(form)
-    >>> print_json(view())
-    {
-        "entries": [
-            {
-                "alt_title": "name12",
-                "alt_title_link": "http://launchpad.dev/~name12",
-                "api_uri": "/~name12",
-                "css": "sprite person",
-                "description": "<email address hidden>",
-                "link_css": "js-action",
-                "metadata": "person",
-                "title": "Sample Person",
-                "value": "name12"
-            }
-        ],
-        "total_size": 1
-    }
-
-IRC nicknames should be displayed after any email address.
-
-    >>> form = dict(name='ValidPersonOrTeam', search_text='mark',
-    ...             start='0', batch='1')
-    >>> view = create_vocabulary_view(form)
-    >>> print_json(view())
-    {
-        "entries": [
-            {
-                "alt_title": "mark",
-                "alt_title_link": "http://launchpad.dev/~mark",
-                "api_uri": "/~mark",
-                "css": "sprite person",
-                "description": "<email address hidden> (mark on irc.freenode.net)",
-                "link_css": "js-action",
-                "metadata": "person",
-                "title": "Mark Shuttleworth",
-                "value": "mark"
-            }
-        ],
-        "total_size": 1
-    }
-
-Clean up the feature flag.
-    >>> flags.cleanUp()

=== modified file 'lib/canonical/launchpad/icing/sprite.css.in'
--- lib/canonical/launchpad/icing/sprite.css.in	2011-08-04 05:21:29 +0000
+++ lib/canonical/launchpad/icing/sprite.css.in	2011-08-04 13:56:55 +0000
@@ -109,6 +109,10 @@
     background-image: url(/@@/link.png); /* sprite-ref: icon-sprites */
     background-repeat: no-repeat;
     }
+.new-window {
+    background-image: url(/@@/new-window.png); /* sprite-ref: icon-sprites */
+    background-repeat: no-repeat;
+    }
 .mail {
     background-image: url(/@@/mail.png); /* sprite-ref: icon-sprites */
     background-repeat: no-repeat;

=== added file 'lib/canonical/launchpad/images/new-window.png'
Binary files lib/canonical/launchpad/images/new-window.png and lib/canonical/launchpad/images/new-window.png differ
=== added file 'lib/lp/app/browser/tests/test_vocabulary.py'
--- lib/lp/app/browser/tests/test_vocabulary.py	1970-01-01 00:00:00 +0000
+++ lib/lp/app/browser/tests/test_vocabulary.py	2011-08-04 15:47:10 +0000
@@ -0,0 +1,272 @@
+# Copyright 2011 Canonical Ltd.  This software is licensed under the
+# GNU Affero General Public License version 3 (see the file LICENSE).
+
+"""Test vocabulary adapters."""
+
+__metaclass__ = type
+
+from datetime import datetime
+from urllib import urlencode
+
+import pytz
+import simplejson
+
+from zope.app.form.interfaces import MissingInputError
+from zope.component import (
+    getSiteManager,
+    getUtility,
+    )
+from zope.interface import implements
+from zope.schema.interfaces import IVocabularyFactory
+from zope.schema.vocabulary import SimpleTerm
+from zope.security.proxy import removeSecurityProxy
+
+
+from canonical.launchpad.interfaces.launchpad import ILaunchpadRoot
+from canonical.launchpad.webapp.vocabulary import (
+    CountableIterator,
+    IHugeVocabulary,
+    )
+from canonical.testing.layers import DatabaseFunctionalLayer
+from lp.app.browser.vocabulary import (
+    IPickerEntry,
+    MAX_DESCRIPTION_LENGTH,
+    )
+from lp.app.errors import UnexpectedFormData
+from lp.registry.interfaces.irc import IIrcIDSet
+from lp.services.features.testing import FeatureFixture
+from lp.testing import (
+    login_person,
+    TestCaseWithFactory,
+    )
+from lp.testing.views import create_view
+
+
+class PersonPickerEntryAdapterTestCase(TestCaseWithFactory):
+
+    layer = DatabaseFunctionalLayer
+
+    def test_person_to_pickerentry(self):
+        # IPerson can be adpated to IPickerEntry.
+        person = self.factory.makePerson()
+        adapter = IPickerEntry(person)
+        self.assertTrue(IPickerEntry.providedBy(adapter))
+
+    def test_PersonPickerEntryAdapter_email_anonymous(self):
+        # Anonymous users cannot see entry email addresses.
+        person = self.factory.makePerson(email='snarf@eg.dom')
+        entry = IPickerEntry(person).getPickerEntry(None)
+        self.assertEqual('<email address hidden>', entry.description)
+
+    def test_PersonPickerEntryAdapter_visible_email_logged_in(self):
+        # Logged in users can see visible email addresses.
+        observer = self.factory.makePerson()
+        login_person(observer)
+        person = self.factory.makePerson(email='snarf@eg.dom')
+        entry = IPickerEntry(person).getPickerEntry(None)
+        self.assertEqual('snarf@eg.dom', entry.description)
+
+    def test_PersonPickerEntryAdapter_hidden_email_logged_in(self):
+        # Logged in users cannot see hidden email addresses.
+        person = self.factory.makePerson(email='snarf@eg.dom')
+        login_person(person)
+        person.hide_email_addresses = True
+        observer = self.factory.makePerson()
+        login_person(observer)
+        entry = IPickerEntry(person).getPickerEntry(None)
+        self.assertEqual('<email address hidden>', entry.description)
+
+    def test_PersonPickerEntryAdapter_no_email_logged_in(self):
+        # Teams without email address have no desriptions.
+        team = self.factory.makeTeam()
+        observer = self.factory.makePerson()
+        login_person(observer)
+        entry = IPickerEntry(team).getPickerEntry(None)
+        self.assertEqual(None, entry.description)
+
+    def test_PersonPickerEntryAdapter_logged_in(self):
+        # Logged in users can see visible email addresses.
+        observer = self.factory.makePerson()
+        login_person(observer)
+        person = self.factory.makePerson(
+            email='snarf@eg.dom', name='snarf')
+        entry = IPickerEntry(person).getPickerEntry(None)
+        self.assertEqual('sprite person', entry.css)
+        self.assertEqual('sprite new-window', entry.link_css)
+
+    def test_PersonPickerEntryAdapter_enhanced_picker_enabled_user(self):
+        # The enhanced person picker provides more information for users.
+        person = self.factory.makePerson(email='snarf@eg.dom', name='snarf')
+        creation_date = datetime(
+            2005, 01, 30, 0, 0, 0, 0, pytz.timezone('UTC'))
+        removeSecurityProxy(person).datecreated = creation_date
+        getUtility(IIrcIDSet).new(person, 'eg.dom', 'snarf')
+        getUtility(IIrcIDSet).new(person, 'ex.dom', 'pting')
+        entry = IPickerEntry(person).getPickerEntry(
+            None, enhanced_picker_enabled=True,
+            picker_expander_enabled=True)
+        self.assertEqual('http://launchpad.dev/~snarf', entry.alt_title_link)
+        self.assertEqual(
+            ['snarf on eg.dom, pting on ex.dom', 'Member since 2005-01-30'],
+            entry.details)
+
+    def test_PersonPickerEntryAdapter_enhanced_picker_enabled_team(self):
+        # The enhanced person picker provides more information for teams.
+        team = self.factory.makeTeam(email='fnord@eg.dom', name='fnord')
+        entry = IPickerEntry(team).getPickerEntry(
+            None, enhanced_picker_enabled=True,
+            picker_expander_enabled=True)
+        self.assertEqual('http://launchpad.dev/~fnord', entry.alt_title_link)
+        self.assertEqual(['Team members: 1'], entry.details)
+
+    def test_PersonPickerEntryAdapter_enhanced_picker_enabled_badges(self):
+        # The enhanced person picker provides affilliation information.
+        person = self.factory.makePerson(email='snarf@eg.dom', name='snarf')
+        project = self.factory.makeProduct(name='fnord', owner=person)
+        bugtask = self.factory.makeBugTask(target=project)
+        entry = IPickerEntry(person).getPickerEntry(
+            bugtask, enhanced_picker_enabled=True,
+            picker_expander_enabled=True)
+        self.assertEqual(1, len(entry.badges))
+        self.assertEqual('/@@/product-badge', entry.badges[0]['url'])
+        self.assertEqual('Affiliated with Fnord', entry.badges[0]['alt'])
+
+
+class TestPersonVocabulary:
+    implements(IHugeVocabulary)
+    test_persons = []
+
+    @classmethod
+    def setTestData(cls, person_list):
+        cls.test_persons = person_list
+
+    def __init__(self, context):
+        self.context = context
+
+    def toTerm(self, person):
+        return SimpleTerm(person, person.name, person.displayname)
+
+    def searchForTerms(self, query=None):
+        found = [
+            person for person in self.test_persons if query in person.name]
+        return CountableIterator(len(found), found, self.toTerm)
+
+
+class HugeVocabularyJSONViewTestCase(TestCaseWithFactory):
+
+    layer = DatabaseFunctionalLayer
+
+    def setUp(self):
+        super(HugeVocabularyJSONViewTestCase, self).setUp()
+        test_persons = []
+        for name in range(1, 7):
+            test_persons.append(
+                self.factory.makePerson(name='pting-%s' % name))
+        TestPersonVocabulary.setTestData(test_persons)
+        getSiteManager().registerUtility(
+            TestPersonVocabulary, IVocabularyFactory, 'TestPerson')
+        self.addCleanup(
+            getSiteManager().unregisterUtility,
+            TestPersonVocabulary, IVocabularyFactory, 'TestPerson')
+        self.addCleanup(TestPersonVocabulary.setTestData, [])
+
+    @staticmethod
+    def create_vocabulary_view(form):
+        context = getUtility(ILaunchpadRoot)
+        query_string = urlencode(form)
+        return create_view(
+            context, '+huge-vocabulary', form=form, query_string=query_string)
+
+    def test_name_field_missing_error(self):
+        view = self.create_vocabulary_view({})
+        self.assertRaisesWithContent(
+            MissingInputError, "('name', '', None)", view.__call__)
+
+    def test_search_text_field_missing_error(self):
+        view = self.create_vocabulary_view({'name': 'TestPerson'})
+        self.assertRaisesWithContent(
+            MissingInputError, "('search_text', '', None)", view.__call__)
+
+    def test_vocabulary_name_unknown_error(self):
+        form = dict(name='snarf', search_text='pting')
+        view = self.create_vocabulary_view(form)
+        self.assertRaisesWithContent(
+            UnexpectedFormData, "Unknown vocabulary 'snarf'", view.__call__)
+
+    def test_json_entries(self):
+        # The results are JSON encoded.
+        feature_flag = {
+            'disclosure.picker_enhancements.enabled': 'on',
+            'disclosure.picker_expander.enabled': 'on',
+            }
+        flags = FeatureFixture(feature_flag)
+        flags.setUp()
+        self.addCleanup(flags.cleanUp)
+        team = self.factory.makeTeam(name='pting-team')
+        TestPersonVocabulary.test_persons.append(team)
+        form = dict(name='TestPerson', search_text='pting-team')
+        view = self.create_vocabulary_view(form)
+        result = simplejson.loads(view())
+        expected = {
+            "alt_title": team.name,
+            "alt_title_link": "http://launchpad.dev/~%s" % team.name,
+            "api_uri": "/~%s" % team.name,
+            "css": "sprite team",
+            "details": ['Team members: 1'],
+            "link_css": "sprite new-window",
+            "metadata": "team",
+            "title": team.displayname,
+            "value": team.name
+            }
+        self.assertTrue('entries' in result)
+        self.assertContentEqual(
+            expected.items(), result['entries'][0].items())
+
+    def test_max_description_size(self):
+        # Descriptions over 120 characters are truncated and ellipsised.
+        email = 'pting-' * 19 + '@example.dom'
+        person = self.factory.makePerson(name='pting-n', email=email)
+        TestPersonVocabulary.test_persons.append(person)
+        # Login to gain permission to know the email address that used
+        # for the description
+        login_person(person)
+        form = dict(name='TestPerson', search_text='pting-n')
+        view = self.create_vocabulary_view(form)
+        result = simplejson.loads(view())
+        expected = (email[:MAX_DESCRIPTION_LENGTH - 3] + '...')
+        self.assertEqual(
+            'pting-n', result['entries'][0]['value'])
+        self.assertEqual(
+            expected, result['entries'][0]['description'])
+
+    def test_default_batch_size(self):
+        # The results are batched.
+        form = dict(name='TestPerson', search_text='pting')
+        view = self.create_vocabulary_view(form)
+        result = simplejson.loads(view())
+        total_size = result['total_size']
+        entries = len(result['entries'])
+        self.assertTrue(
+            total_size > entries,
+            'total_size: %d is less than entries: %d' % (total_size, entries))
+
+    def test_batch_size(self):
+        # A The batch size can be specified with the batch param.
+        form = dict(
+            name='TestPerson', search_text='pting',
+            start='0', batch='1')
+        view = self.create_vocabulary_view(form)
+        result = simplejson.loads(view())
+        self.assertEqual(6, result['total_size'])
+        self.assertEqual(1, len(result['entries']))
+
+    def test_start_offset(self):
+        # The offset of the batch is specified with the start param.
+        form = dict(
+            name='TestPerson', search_text='pting',
+            start='1', batch='1')
+        view = self.create_vocabulary_view(form)
+        result = simplejson.loads(view())
+        self.assertEqual(6, result['total_size'])
+        self.assertEqual(1, len(result['entries']))
+        self.assertEqual('pting-2', result['entries'][0]['value'])

=== modified file 'lib/lp/app/browser/vocabulary.py'
--- lib/lp/app/browser/vocabulary.py	2011-08-04 05:21:29 +0000
+++ lib/lp/app/browser/vocabulary.py	2011-08-04 15:18:04 +0000
@@ -32,6 +32,7 @@
 from canonical.launchpad.webapp.interfaces import NoCanonicalUrl
 from canonical.launchpad.webapp.publisher import canonical_url
 from lp.app.browser.tales import (
+    DateTimeFormatterAPI,
     IRCNicknameFormatterAPI,
     ObjectImageDisplayAPI,
     )
@@ -61,6 +62,7 @@
     css = Attribute('CSS Class')
     alt_title = Attribute('Alternative title')
     title_link = Attribute('URL used for anchor on title')
+    details = Attribute('An optional list of information about the entry')
     alt_title_link = Attribute('URL used for anchor on alt title')
     link_css = Attribute('CSS Class for links')
     badges = Attribute('List of badge img attributes')
@@ -72,13 +74,14 @@
     implements(IPickerEntry)
 
     def __init__(self, description=None, image=None, css=None, alt_title=None,
-                 title_link=None, alt_title_link=None, link_css='js-action',
-                 badges=None, metadata=None):
+                 title_link=None, details=None, alt_title_link=None,
+                 link_css='sprite new-window', badges=None, metadata=None):
         self.description = description
         self.image = image
         self.css = css
         self.alt_title = alt_title
         self.title_link = title_link
+        self.details = details
         self.alt_title_link = alt_title_link
         self.link_css = link_css
         self.badges = badges
@@ -137,6 +140,10 @@
                 extra.badges = [
                     dict(url=badge_info.url, alt=badge_info.alt_text)]
 
+        picker_expander_enabled = kwarg.get('picker_expander_enabled', False)
+        if picker_expander_enabled:
+            extra.details = []
+
         if person.preferredemail is not None:
             if person.hide_email_addresses:
                 extra.description = '<email address hidden>'
@@ -161,12 +168,22 @@
                 irc_nicks = ", ".join(
                     [IRCNicknameFormatterAPI(ircid).displayname()
                     for ircid in person.ircnicknames])
-            if irc_nicks:
+            if irc_nicks and not picker_expander_enabled:
                 if extra.description:
                     extra.description = ("%s (%s)" %
                         (extra.description, irc_nicks))
                 else:
                     extra.description = "%s" % irc_nicks
+            if picker_expander_enabled:
+                if irc_nicks:
+                    extra.details.append(irc_nicks)
+                if person.is_team:
+                    extra.details.append(
+                        'Team members: %s' % person.all_member_count)
+                else:
+                    extra.details.append(
+                        'Member since %s' % DateTimeFormatterAPI(
+                            person.datecreated).date())
 
         return extra
 
@@ -223,6 +240,8 @@
         self.request = request
         self.enhanced_picker_enabled = bool(
             getFeatureFlag('disclosure.picker_enhancements.enabled'))
+        self.picker_expander_enabled = bool(
+            getFeatureFlag('disclosure.picker_expander.enabled'))
 
     def __call__(self):
         name = self.request.form.get('name')
@@ -267,7 +286,8 @@
                 entry['api_uri'] = 'Could not find canonical url.'
             picker_entry = IPickerEntry(term.value).getPickerEntry(
                 self.context,
-                enhanced_picker_enabled=self.enhanced_picker_enabled)
+                enhanced_picker_enabled=self.enhanced_picker_enabled,
+                picker_expander_enabled=self.picker_expander_enabled)
             if picker_entry.description is not None:
                 if len(picker_entry.description) > MAX_DESCRIPTION_LENGTH:
                     entry['description'] = (
@@ -283,6 +303,8 @@
                 entry['alt_title'] = picker_entry.alt_title
             if picker_entry.title_link is not None:
                 entry['title_link'] = picker_entry.title_link
+            if picker_entry.details is not None:
+                entry['details'] = picker_entry.details
             if picker_entry.alt_title_link is not None:
                 entry['alt_title_link'] = picker_entry.alt_title_link
             if picker_entry.link_css is not None:

=== modified file 'lib/lp/app/javascript/picker/picker.js'
--- lib/lp/app/javascript/picker/picker.js	2011-08-04 05:21:29 +0000
+++ lib/lp/app/javascript/picker/picker.js	2011-08-04 15:47:10 +0000
@@ -380,24 +380,32 @@
             data.title, data.title_link, data.link_css);
         li_title.appendChild(title);
         if (data.alt_title) {
-            var alt_link = null;
-            if (data.alt_title_link) {
-                alt_link =Y.Node.create('<a></a>')
-                    .addClass(data.link_css)
-                    .addClass('discreet');
-                alt_link.set('text', " Details...")
-                    .set('href', data.alt_title_link);
-                Y.on('click', function(e) {
-                    e.halt();
-                    window.open(data.alt_title_link);
-                }, alt_link);
+            if (!data.details) {
+                // XXX sinzui 2011-08-04: Remove this block when expanders
+                // are released.
+                var alt_link = null;
+                if (data.alt_title_link) {
+                    alt_link =Y.Node.create('<a></a>')
+                        .addClass(data.link_css)
+                        .addClass('discreet');
+                    alt_link.set('text', " Details...")
+                        .set('href', data.alt_title_link);
+                    Y.on('click', function(e) {
+                        e.halt();
+                        window.open(data.alt_title_link);
+                    }, alt_link);
+                }
             }
+
             li_title.appendChild('&nbsp;(');
             var alt_title_node = Y.Node.create('<span></span>')
                 .set('text', data.alt_title);
             li_title.appendChild(alt_title_node);
             li_title.appendChild(')');
             if (alt_link !== null) {
+                // XXX sinzui 2011-08-04: Remove this block when expanders
+                // are released.
+                li_title.appendChild(Y.Node.create('&nbsp;&nbsp;'));
                 li_title.appendChild(alt_link);
             }
         }
@@ -412,7 +420,8 @@
      */
     _renderBadgesUI: function(data) {
         if (data.badges) {
-            var badges = Y.Node.create('<div></div>').addClass('badge');
+            var badges = Y.Node.create('<div>Affiliation:</div>')
+                .addClass('badge');
             Y.each(data.badges, function(badge_info) {
                 var badge_url = badge_info.url;
                 var badge_alt = badge_info.alt;
@@ -443,6 +452,46 @@
     },
 
     /**
+     * Render a node containing the optional details part of the picker entry.
+     * @param data a json data object with the details to render
+     */
+    _renderDetailsUI: function(data) {
+        if (!data.details) {
+            return null;
+        }
+        var details_node = Y.Node.create('<div></div>')
+            .addClass('sprite')
+            .addClass(C_RESULT_DESCRIPTION);
+        if (Y.Lang.isArray(data.details)) {
+            var data_node = Y.Node.create('<div></div>');
+            var escaped_details = [];
+            Y.Array.each(data.details, function(detail, i) {
+                escaped_details.push(Y.Escape.html(detail));
+                });
+            data_node.append(Y.Node.create(escaped_details.join('<br />')));
+            details_node.append(data_node);
+        }
+        var links = [];
+        links.push(Y.Node.create(
+            '<a class="sprite yes save" href="#"></a>')
+                .set('text', 'Select ' + data.title));
+        links[0].on('click', function (e, value) {
+            this.fire(SAVE, value);
+            }, this, data);
+        links.push(this._text_or_link(
+            'View details', data.alt_title_link, data.link_css));
+        var link_list = Y.Node.create('<ul></ul>')
+            .addClass('horizontal');
+        Y.Array.each(links, function(link, i) {
+            var li = Y.Node.create('<li></li>');
+            li.append(link);
+            link_list.append(li);
+            });
+        details_node.append(link_list);
+        return details_node;
+    },
+
+    /**
      * Update the UI based on the results attribute.
      *
      * @method _syncResultsUI
@@ -462,6 +511,8 @@
             var li_title = this._renderTitleUI(data);
             // Sort out the description div.
             var li_desc = this._renderDescriptionUI(data);
+            // Sort out the optional details div.
+            var li_details = this._renderDetailsUI(data);
             // Put the list item together.
             var li = Y.Node.create('<li></li>').addClass(
                 i % 2 ? Y.lazr.ui.CSS_ODD : Y.lazr.ui.CSS_EVEN);
@@ -475,12 +526,22 @@
             if (li_badges !== null) {
                 li.appendChild(li_badges);
             }
-            li.appendChild(li_title);
-            li.appendChild(li_desc);
-            // Attach handlers.
-            li.on('click', function (e, value) {
-                this.fire(SAVE, value);
-            }, this, data);
+            var summary_node = Y.Node.create('<div></div>');
+            summary_node.appendChild(li_title);
+            summary_node.appendChild(li_desc);
+            li.appendChild(summary_node);
+            if (li_details) {
+                // Use explicit save link.
+                li.appendChild(li_details);
+                li.expander = new Y.lp.app.widgets.expander.Expander(
+                    summary_node, li_details);
+                li.expander.setUp();
+            } else {
+                // Attach implicit save handler.
+                li.on('click', function (e, value) {
+                    this.fire(SAVE, value);
+                    }, this, data);
+            }
 
             this._results_box.appendChild(li);
         }, this);
@@ -1066,7 +1127,8 @@
 namespace.TextFieldPickerPlugin = TextFieldPickerPlugin;
 
 }, "0.1", {"skinnable": true,
-           "requires": ["oop", "event", "event-focus", "node", "plugin",
-                        "substitute", "widget", "widget-stdmod",
-                        "lazr.overlay", "lazr.anim", "lazr.base"]
+           "requires": ["oop", "escape", "event", "event-focus", "node",
+                        "plugin", "substitute", "widget", "widget-stdmod",
+                        "lazr.overlay", "lazr.anim", "lazr.base",
+                        "lp.app.widgets.expander"]
 });

=== modified file 'lib/lp/app/javascript/picker/tests/test_picker.html'
--- lib/lp/app/javascript/picker/tests/test_picker.html	2011-08-04 05:21:29 +0000
+++ lib/lp/app/javascript/picker/tests/test_picker.html	2011-08-04 13:56:55 +0000
@@ -15,7 +15,9 @@
   <!-- The module under test -->
   <script type="text/javascript" src="../../overlay/overlay.js"></script>
   <script type="text/javascript" src="../picker.js"></script>
+  <script type="text/javascript" src="../../expander.js"></script>
   <script type="text/javascript" src="../../anim/anim.js"></script>
+  <script type="text/javascript" src="../../effects/effects.js"></script>
   <script type="text/javascript" src="../../lazr/lazr.js"></script>
 
   <!-- The test suite -->

=== modified file 'lib/lp/app/javascript/picker/tests/test_picker.js'
--- lib/lp/app/javascript/picker/tests/test_picker.js	2011-08-04 05:21:29 +0000
+++ lib/lp/app/javascript/picker/tests/test_picker.js	2011-08-04 15:18:04 +0000
@@ -148,7 +148,8 @@
                 alt_title: 'Joe Again <foo></foo>',
                 title_link: 'http://somewhere.com',
                 alt_title_link: 'http://somewhereelse.com',
-                link_css: 'cool-style'
+                link_css: 'cool-style',
+                details: ['Member since 2007'],
             }
         ]);
 
@@ -171,13 +172,88 @@
             this.picker, 'a.cool-style:nth-child(1)', 'Joe Schmo',
             'http://somewhere.com/');
         check_link(
-            this.picker, 'a.cool-style:nth-child(3)', ' Details...',
+            this.picker, 'a.cool-style:last-child', 'View details',
             'http://somewhereelse.com/');
         var alt_text_node = this.picker.get('boundingBox')
             .one('.yui3-picker-result-title span');
         Assert.areEqual('Joe Again <foo></foo>', alt_text_node.get('text'));
     },
 
+    test_details: function () {
+        // The details of the li is the content node of the expander.
+        this.picker.render();
+        this.picker.set('results', [
+            {
+                css: 'yui3-blah-blue',
+                value: 'jschmo',
+                title: 'Joe Schmo',
+                description: 'joe@example.com',
+                details: ['joe on irc.freenode.net', 'Member since 2007'],
+                alt_title_link: '/~jschmo'
+            }
+        ]);
+        var bb = this.picker.get('boundingBox');
+        var li = bb.one('.yui3-picker-results li');
+        var details = li.expander.content_node;
+        Assert.areEqual(
+            'joe on irc.freenode.net<br>Member since 2007',
+            details.one('div').getContent());
+        Assert.areEqual(
+            'Select Joe Schmo', details.one('ul li:first-child').get('text'));
+        Assert.areEqual(
+            'View details', details.one('ul li:last-child').get('text'));
+    },
+
+    test_details_escaping: function () {
+        // The content of details is escaped.
+        this.picker.render();
+        this.picker.set('results', [
+            {
+                css: 'yui3-blah-blue',
+                value: 'jschmo',
+                title: 'Joe <Schmo>',
+                description: 'joe@example.com',
+                details: ['<joe> on irc.freenode.net', 'f<nor>d maintainer'],
+                alt_title_link: '/~jschmo'
+            }
+        ]);
+        var bb = this.picker.get('boundingBox');
+        var li = bb.one('.yui3-picker-results li');
+        var details = li.expander.content_node;
+        Assert.areEqual(
+            '&lt;joe&gt; on irc.freenode.net<br>f&lt;nor&gt;d maintainer',
+            details.one('div').getContent());
+        Assert.areEqual(
+            'Select Joe &lt;Schmo&gt;',
+            details.one('ul li:first-child a').getContent('text'));
+    },
+
+    test_details_save_link: function () {
+        // The select link the li's details saves the selection.
+        this.picker.render();
+        this.picker.set('results', [
+            {
+                css: 'yui3-blah-blue',
+                value: 'jschmo',
+                title: 'Joe Schmo',
+                description: 'joe@example.com',
+                alt_title_link: 'http://somewhereelse.com',
+                link_css: 'cool-style',
+                details: ['Member since 2007'],
+            }
+        ]);
+        var bb = this.picker.get('boundingBox');
+        var link_node = bb.one('a.save');
+        Assert.areEqual('Select Joe Schmo', link_node.get('text'));
+        Assert.isTrue(link_node.get('href').indexOf(window.location) === 0);
+        var selected_value = null;
+        this.picker.subscribe('save', function(e) {
+            selected_value = e.details[0].value;
+        }, this);
+        simulate(bb, 'a.save', 'click');
+        Assert.areEqual('jschmo', selected_value);
+    },
+
     test_title_badges: function () {
         this.picker.render();
         var badge_info = [

=== modified file 'lib/lp/bugs/templates/bugtarget-macros-filebug.pt'
--- lib/lp/bugs/templates/bugtarget-macros-filebug.pt	2011-08-04 05:21:29 +0000
+++ lib/lp/bugs/templates/bugtarget-macros-filebug.pt	2011-08-04 13:56:55 +0000
@@ -389,7 +389,8 @@
                       content="bug/date_last_updated/fmt:approximatedate">
                     2007-07-03
                   </tal:last-updated>
-                  <a class="view-bug-link" target="_blank"
+                  &nbsp;&nbsp;
+                  <a class="sprite new-window view-bug-link" target="_blank"
 		      tal:attributes="href bug/fmt:url"
                   >view this bug</a>
                 </span>

=== modified file 'lib/lp/registry/model/pillaraffiliation.py'
--- lib/lp/registry/model/pillaraffiliation.py	2011-08-04 05:21:29 +0000
+++ lib/lp/registry/model/pillaraffiliation.py	2011-08-04 13:56:55 +0000
@@ -30,6 +30,7 @@
 
 from canonical.launchpad.interfaces.launchpad import IHasIcon
 from lp.bugs.interfaces.bugtask import IBugTask
+from lp.registry.interfaces.distribution import IDistribution
 
 
 class IHasAffiliation(Interface):
@@ -80,14 +81,10 @@
                 icon_url = context.icon.getURL()
                 return icon_url
             return default_url
-        
-        if self.context.distribution or self.context.distroseries:
-            icon_url = getIconUrl(
-                self.context.distribution or self.context.distroseries.distribution,
-                "/@@/distribution-badge")
-            return BadgeDetails(icon_url, "Affiliated with Ubuntu")
-        if self.context.product or self.context.productseries:
-            icon_url = getIconUrl(
-                self.context.product or self.context.productseries.product,
-                "/@@/product-badge")
-            return BadgeDetails(icon_url, "Affiliated with Launchpad itself")
+
+        alt_text = "Affiliated with %s" % pillar.displayname
+        if IDistribution.providedBy(pillar):
+            icon_url = getIconUrl(pillar, "/@@/distribution-badge")
+        else:
+            icon_url = getIconUrl(pillar, "/@@/product-badge")
+        return BadgeDetails(icon_url, alt_text)

=== modified file 'lib/lp/registry/tests/test_pillaraffiliation.py'
--- lib/lp/registry/tests/test_pillaraffiliation.py	2011-08-04 05:21:29 +0000
+++ lib/lp/registry/tests/test_pillaraffiliation.py	2011-08-04 13:56:55 +0000
@@ -17,17 +17,17 @@
     def test_bugtask_distro_affiliation(self):
         # A person who owns a bugtask distro is affiliated.
         person = self.factory.makePerson()
-        distro = self.factory.makeDistribution(owner=person)
+        distro = self.factory.makeDistribution(owner=person, name='pting')
         bugtask = self.factory.makeBugTask(target=distro)
         badge = IHasAffiliation(bugtask).getAffiliationBadge(person)
         self.assertEqual(
-            badge, ("/@@/distribution-badge", "Affiliated with Ubuntu"))
+            badge, ("/@@/distribution-badge", "Affiliated with Pting"))
 
     def test_bugtask_product_affiliation(self):
         # A person who owns a bugtask product is affiliated.
         person = self.factory.makePerson()
-        product = self.factory.makeProduct(owner=person)
+        product = self.factory.makeProduct(owner=person, name='pting')
         bugtask = self.factory.makeBugTask(target=product)
         badge = IHasAffiliation(bugtask).getAffiliationBadge(person)
         self.assertEqual(
-            badge, ("/@@/product-badge", "Affiliated with Launchpad itself"))
+            badge, ("/@@/product-badge", "Affiliated with Pting"))

=== modified file 'lib/lp/services/features/flags.py'
--- lib/lp/services/features/flags.py	2011-08-02 23:42:08 +0000
+++ lib/lp/services/features/flags.py	2011-08-04 15:18:04 +0000
@@ -112,6 +112,10 @@
      'boolean',
      ('Enables the display of extra details in the person picker.'),
      ''),
+    ('disclosure.picker_expander.enabled',
+     'boolean',
+     ('Enables the expanding of extra details in the person picker.'),
+     ''),
     ('disclosure.person_affiliation_rank.enabled',
      'boolean',
      ('Enables ranking by pillar affiliation in the person picker.'),

